/**
 * @file Dezibot.h
 * @author your name (you@domain.com)
 * @brief 
 * @version 0.1
 * @date 2023-11-19
 * 
 * @copyright Copyright (c) 2023
 * 
 */
#ifndef Dezibot_h
#define Dezibot_h

#include "motion/Motion.h"
#include "lightDetection/LightDetection.h"
#include "colorDetection/ColorDetection.h"
#include "multiColorLight/MultiColorLight.h"
#include "motionDetection/MotionDetection.h"
#include "Arduino.h"
#include "Wire.h"

class Dezibot {
protected:

public:
    Dezibot();
    LightDetection lightDetection;
    ColorDetection colorDetection;
    MultiColorLight multiColorLight;
    Motion motion ;
    void begin(void);

};

#endif //Dezibot_h